#include <stdio.h>
#include <conio.h>
#include <dos.h>
#include <graphics.h>
#include <math.h>

#define FALSE 0
#define TRUE  1

#define SEG_LENGTH 	100
#define SEG_WIDTH  	25
#define SEG_GAP    	10
#define SEG_A_X	   	100
#define SEG_A_Y    	20
#define SEG_COLOUR	GREEN
#define SEG_FILL	SOLID_FILL
#define SEG_BORDER	WHITE

#define CAL_LENGTH 	100
#define CAL_WIDTH  	25
#define CAL_OFFSET 	200
#define CAL_X      	( SEG_A_X + SEG_LENGTH + SEG_GAP + CAL_OFFSET )
#define CAL_Y      	( SEG_A_Y )

#define WELCOME_TEXT_X  5
#define WELCOME_TEXT_Y  5

#define TEXTBOX_LENGTH	100
#define TEXTBOX_WIDTH	25
#define TEXTBOX_OFFSET	50
#define TEXTBOX_X	( SEG_A_X + SEG_LENGTH + SEG_GAP + CAL_OFFSET )
#define TEXTBOX_Y	( SEG_A_Y + SEG_WIDTH  + SEG_GAP + TEXTBOX_OFFSET )

#define TEXTBOX_TEXT_OFFSET  5
#define TEXTBOX_TEXT_X       ( TEXTBOX_X + TEXTBOX_TEXT_OFFSET )
#define TEXTBOX_TEXT_Y       ( TEXTBOX_Y + TEXTBOX_TEXT_OFFSET )

#define CONNECTION_GAP      20
#define CONNECTION_OFFSET   75
#define CONNECTION_X        ( TEXTBOX_X )
#define CONNECTION_Y        ( TEXTBOX_Y + CONNECTION_OFFSET )

#define ESC_KEY             27

#define NUM_OBJECTS     8

char obj_names[][10] = { "a",
			 "b" ,
			 "c" ,
			 "d" ,
			 "e",
			 "f",
			 "g",
			 "calc",
			 "no click"
		       } ;

typedef struct
{
 int start_x ;
 int start_y ;
 int end_x ;
 int end_y ;
} object_loc ;

typedef struct
{
 object_loc *loc ;
 int obj_count ;
} objects ;

objects buttons ;
int obj_state[ NUM_OBJECTS ] ;

void welcome_screen( void ) ;
void init_program( void );
void exit_program( void ) ;
int  init_mouse( void ) ;
void init_graphics( void ) ;
void init_objects( void ) ;
void draw_display( void ) ;
void add_object( int, int, int, int ) ;
char get_key_pressed( void ) ;
void process_key( char )  ;
int  calculate_value( void ) ;
void num2str( int, char* ) ;


void main()
{
 int val ;
 int key ;
 char str[50] ;

 init_program() ;

 do
 {
  draw_display() ;

  key = get_key_pressed() ;

  process_key( key ) ;

 }while( key != ESC_KEY );

 exit_program() ;
}	/* end of MAIN */


void welcome_screen( void )
{
 clrscr() ;

 gotoxy( WELCOME_TEXT_X ,
	 WELCOME_TEXT_Y ) ;
 printf( "Program to calculate the hex value to light up an 7 SEG display" ) ;

 gotoxy( WELCOME_TEXT_X ,
	 WELCOME_TEXT_Y + 1 ) ;
 printf( "- Veeresh" ) ;

 textcolor( LIGHTGREEN + BLINK ) ;
 gotoxy( WELCOME_TEXT_X ,
	 WELCOME_TEXT_Y + 2 ) ;

 printf( "Press any key to continue" ) ;

 getch() ;
}	/* end of WELCOME_SCREEN */


void init_program( void )
{
 welcome_screen() ;

 init_graphics() ;

 init_objects() ;
}

void exit_program( void )
{
 free( buttons.loc ) ;

 closegraph() ;
}

void init_graphics( void )
{
 int gd= DETECT, gm = 0 ;

 initgraph( &gd, &gm, "" ) ;
}	/* end of INIT_GRAPHICS */


void init_objects( void )
{
 int i ;

 buttons.loc = (object_loc*) malloc( NUM_OBJECTS * sizeof(object_loc) ) ;

 for( i=0 ; i<NUM_OBJECTS ; i++ )
 {
  obj_state[ i ] = FALSE ;
 }

 buttons.obj_count = 0 ;

 /* segment A */
 add_object( SEG_A_X ,
	     SEG_A_Y ,
	     SEG_A_X + SEG_LENGTH ,
	     SEG_A_Y + SEG_WIDTH ) ;

 /* segment B */
 add_object( SEG_A_X + SEG_LENGTH + SEG_GAP ,
	     SEG_A_Y + SEG_WIDTH + SEG_GAP ,
	     SEG_A_X + SEG_LENGTH + SEG_GAP + SEG_WIDTH ,
	     SEG_A_Y + SEG_WIDTH + SEG_GAP + SEG_LENGTH ) ;

 /* segment C */
 add_object( SEG_A_X + SEG_LENGTH + SEG_GAP ,
	     SEG_A_Y + 2 * SEG_WIDTH + SEG_LENGTH + 3 * SEG_GAP ,
	     SEG_A_X + SEG_LENGTH + SEG_GAP + SEG_WIDTH ,
	     SEG_A_Y + 2 * SEG_WIDTH + 2 * SEG_LENGTH + 3 * SEG_GAP ) ;

 /* segment D */
 add_object( SEG_A_X ,
	     SEG_A_Y + 2 * SEG_WIDTH + 2 * SEG_LENGTH + 4 * SEG_GAP ,
	     SEG_A_X + SEG_LENGTH ,
	     SEG_A_Y + 3 * SEG_WIDTH + 2 * SEG_LENGTH + 4 * SEG_GAP ) ;

 /* segment E */
 add_object( SEG_A_X - SEG_GAP - SEG_WIDTH ,
	     SEG_A_Y + 2 * SEG_WIDTH + SEG_LENGTH + 3 * SEG_GAP ,
	     SEG_A_X - SEG_GAP ,
	     SEG_A_Y + 2 * SEG_WIDTH + 2 * SEG_LENGTH + 3 * SEG_GAP ) ;

 /* segment F */
 add_object( SEG_A_X - SEG_GAP - SEG_WIDTH ,
	     SEG_A_Y + SEG_WIDTH + SEG_GAP ,
	     SEG_A_X - SEG_GAP ,
	     SEG_A_Y + SEG_WIDTH + SEG_GAP + SEG_LENGTH ) ;

 /* segment G */
 add_object( SEG_A_X ,
	     SEG_A_Y + SEG_WIDTH + SEG_LENGTH + 2 * SEG_GAP ,
	     SEG_A_X + SEG_LENGTH ,
	     SEG_A_Y + 2 * SEG_WIDTH + SEG_LENGTH + 2 * SEG_GAP ) ;

}	/* end of INIT_OBJECTS */


void draw_display( void )
{
 int i ;
 int value ;
 char str[4] ;

 cleardevice() ;

 /* segment A */
 rectangle( SEG_A_X ,
	    SEG_A_Y ,
	    SEG_A_X + SEG_LENGTH ,
	    SEG_A_Y + SEG_WIDTH ) ;

 /* segment B */
 rectangle( SEG_A_X + SEG_LENGTH + SEG_GAP ,
	    SEG_A_Y + SEG_WIDTH + SEG_GAP ,
	    SEG_A_X + SEG_LENGTH + SEG_GAP + SEG_WIDTH ,
	    SEG_A_Y + SEG_WIDTH + SEG_GAP + SEG_LENGTH ) ;

 /* segment C */
 rectangle( SEG_A_X + SEG_LENGTH + SEG_GAP ,
	    SEG_A_Y + 2 * SEG_WIDTH + SEG_LENGTH + 3 * SEG_GAP ,
	    SEG_A_X + SEG_LENGTH + SEG_GAP + SEG_WIDTH ,
	    SEG_A_Y + 2 * SEG_WIDTH + 2 * SEG_LENGTH + 3 * SEG_GAP ) ;

 /* segment D */
 rectangle( SEG_A_X ,
	    SEG_A_Y + 2 * SEG_WIDTH + 2 * SEG_LENGTH + 4 * SEG_GAP ,
	    SEG_A_X + SEG_LENGTH ,
	    SEG_A_Y + 3 * SEG_WIDTH + 2 * SEG_LENGTH + 4 * SEG_GAP ) ;

 /* segment E */
 rectangle( SEG_A_X - SEG_GAP - SEG_WIDTH ,
	    SEG_A_Y + 2 * SEG_WIDTH + SEG_LENGTH + 3 * SEG_GAP ,
	    SEG_A_X - SEG_GAP ,
	    SEG_A_Y + 2 * SEG_WIDTH + 2 * SEG_LENGTH + 3 * SEG_GAP ) ;

 /* segment F */
 rectangle( SEG_A_X - SEG_GAP - SEG_WIDTH ,
	    SEG_A_Y + SEG_WIDTH + SEG_GAP ,
	    SEG_A_X - SEG_GAP ,
	    SEG_A_Y + SEG_WIDTH + SEG_GAP + SEG_LENGTH ) ;

 /* segment G */
 rectangle( SEG_A_X ,
	    SEG_A_Y + SEG_WIDTH + SEG_LENGTH + 2 * SEG_GAP ,
	    SEG_A_X + SEG_LENGTH ,
	    SEG_A_Y + 2 * SEG_WIDTH + SEG_LENGTH + 2 * SEG_GAP ) ;

 /* textbox to display value */
 rectangle( TEXTBOX_X ,
	    TEXTBOX_Y ,
	    TEXTBOX_X + TEXTBOX_LENGTH ,
	    TEXTBOX_Y + TEXTBOX_WIDTH ) ;
 outtextxy( TEXTBOX_X ,
	    TEXTBOX_Y - textheight( "VALUE - 'M/m'" ) ,
	    "VALUE(decimal)" ) ;

 /* display conenction details */
 outtextxy( CONNECTION_X ,
	    CONNECTION_Y ,
	    "A (a/0) --- P0.0" ) ;

 outtextxy( CONNECTION_X ,
	    CONNECTION_Y + CONNECTION_GAP ,
	    "B (b/1) --- P0.1" ) ;

 outtextxy( CONNECTION_X ,
	    CONNECTION_Y + 2 * CONNECTION_GAP ,
	    "C (c/2) --- P0.2" ) ;

 outtextxy( CONNECTION_X ,
	    CONNECTION_Y + 3 * CONNECTION_GAP ,
	    "D (d/3) --- P0.3" ) ;

 outtextxy( CONNECTION_X ,
	    CONNECTION_Y + 4 * CONNECTION_GAP ,
	    "E (e/4) --- P0.4" ) ;

 outtextxy( CONNECTION_X ,
	    CONNECTION_Y + 5 * CONNECTION_GAP ,
	    "F (f/5) --- P0.5" ) ;

 outtextxy( CONNECTION_X ,
	    CONNECTION_Y + 6 * CONNECTION_GAP ,
	    "G (g/6) --- P0.6" ) ;

 for( i = 0 ; i < NUM_OBJECTS ; i++ )
 {
  setfillstyle( SEG_FILL ,
		( obj_state[i] != FALSE )  ?  SEG_COLOUR : getbkcolor() ) ;

  floodfill( buttons. loc[i]. start_x + SEG_WIDTH/2 ,
	     buttons. loc[i]. start_y + SEG_WIDTH/2 ,
	     SEG_BORDER ) ;

  outtextxy( buttons.loc[i].start_x + SEG_WIDTH/2 + 2 ,
	     buttons.loc[i].start_y + SEG_WIDTH/2 + 2 ,
	     obj_names[i] ) ;
 }

 value = calculate_value() ;

 num2str( value, str ) ;
 outtextxy( TEXTBOX_TEXT_X, TEXTBOX_TEXT_Y , str ) ;
} /* end of DRAW_DISPLAY */


void add_object( int x, int y, int xdx, int ydy )
{
 rectangle( x ,
	    y ,
	    xdx ,
	    ydy ) ;

 buttons. loc[buttons.obj_count]. start_x = x ;
 buttons. loc[buttons.obj_count]. start_y = y ;
 buttons. loc[buttons.obj_count]. end_x   = xdx ;
 buttons. loc[buttons.obj_count]. end_y   = ydy ;

 buttons.obj_count ++ ;
}


char get_key_pressed( void )
{
 int count = 5000 ;

 while( count-- && !kbhit() ) ;

 return( getch() ) ;
}	/* end of GET_KEY_PRESSED */


void process_key( char key )
{
 char obj ;
 int value ;
 char str[4] ;

 if( key == 'a' || key == 'A' || key == '0' )
 {
  obj = 'a' ;
 }
 else if( key == 'b' || key == 'B' || key == '1' )
 {
  obj = 'b' ;
 }
 else if( key == 'c' || key == 'C' || key == '2' )
 {
  obj = 'c' ;
 }
 else if( key == 'd' || key == 'D' || key == '3' )
 {
  obj = 'd' ;
 }
 else if( key == 'e' || key == 'E' || key == '4' )
 {
  obj = 'e' ;
 }
 else if( key == 'f' || key == 'F' || key == '5' )
 {
  obj = 'f' ;
 }
 else if( key == 'g' || key == 'G' || key == '6' )
 {
  obj = 'g' ;
 }

 switch( obj )
 {
  case 'a' : obj_state[0] = obj_state[0] ? FALSE : TRUE ;
	     break ;

  case 'b' : obj_state[1] = obj_state[1] ? FALSE : TRUE ;
	     break ;

  case 'c' : obj_state[2] = obj_state[2] ? FALSE : TRUE ;
	     break ;

  case 'd' : obj_state[3] = obj_state[3] ? FALSE : TRUE ;
	     break ;

  case 'e' : obj_state[4] = obj_state[4] ? FALSE : TRUE ;
	     break ;

  case 'f' : obj_state[5] = obj_state[5] ? FALSE : TRUE ;
	     break ;

  case 'g' : obj_state[6] = obj_state[6] ? FALSE : TRUE ;
	     break ;

  case 'm' : value = calculate_value() ;

	     cleardevice() ;
	     draw_display() ;

	     num2str( value, str ) ;
	     outtextxy( TEXTBOX_TEXT_X, TEXTBOX_TEXT_Y , str ) ;
	     break ;
 }
}	/* end of PROCESS_KEY */


int calculate_value( void )
{
 int sum ;
 int i ;

 sum = 0 ;
 for( i=0 ; i<7 ; i++ )
 {
  sum += obj_state[i] ? pow( 2, i) : 0 ;
 }

 return( sum ) ;
}	/* end of CALCULATE_VALUE */


void num2str( int value, char* str )
{
 int divisor ;
 int len ;

 divisor = 100 ;
 len = 0 ;

 if( value == 0 )
 {
  strcpy( str, "0" ) ;
 }
 else
 {
  while( value > 0 )
  {
   if( ( (value/divisor) ) )
   {
    str[len] = (value / divisor) + '0' ;
    len++ ;
   }

   value %= divisor ;
   divisor /= 10 ;
  }

  str[len] = '\0' ;
 }
}	/* end of NUM2STR */